Index: source/ariba/Makefile.am
===================================================================
--- source/ariba/Makefile.am	(revision 5638)
+++ source/ariba/Makefile.am	(revision 5640)
@@ -111,134 +111,4 @@
 nobase_libariba_la_HEADERS += \
   communication/messages/AribaBaseMsg.h
-
-# ------------> communication :: modules
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/modules.h \
-#  communication/modules/_namespace.h
-
-# ------------> communication :: modules :: network
-
-#libariba_la_SOURCES += \
-#  communication/modules/network/NetworkLocator.cpp \
-#  communication/modules/network/NetworkProtocol.cpp
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/network/NetworkLocator.h \
-#  communication/modules/network/NetworkProtocol.h
-
-# ------------> communication :: modules :: network :: ip
-
-#libariba_la_SOURCES += \
-#  communication/modules/network/ip/IPv4Locator.cpp \
-#  communication/modules/network/ip/IPv4NetworkProtocol.cpp
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/network/ip/IPv4Locator.h  \
-#  communication/modules/network/ip/IPv4NetworkProtocol.h
-
-# ------------> communication :: modules :: network :: omnet
-
-#if OMNET
-#libariba_la_SOURCES += \
-#  communication/modules/network/omnet/OmnetNetworkProtocol.cpp
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/network/omnet/OmnetNetworkProtocol.h
-#endif
-
-#------------> communication :: modules :: transport
-
-#libariba_la_SOURCES += \
-#  communication/modules/transport/TransportLocator.cpp \
-#  communication/modules/transport/TransportProtocol.cpp
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/transport/TransportLocator.h \
-#  communication/modules/transport/TransportProtocol.h
-
-#------------> communication :: modules :: transport :: omnet
-
-#if OMNET
-#libariba_la_SOURCES += \
-#  communication/modules/transport/omnet/AribaOmnetMessage_m.cc \
-#  communication/modules/transport/omnet/AribaOmnetModule.cpp
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/transport/omnet/AribaOmnetMessage_m.h \
-#  communication/modules/transport/omnet/AribaOmnetModule.h
-#endif
-
-#------------> communication :: modules :: transport :: protlib
-
-if OMNET
-else
-#libariba_la_SOURCES += \
-#  communication/modules/transport/protlib/timer_module.cpp \
-#  communication/modules/transport/protlib/threadsafe_db.cpp \
-#  communication/modules/transport/protlib/address.cpp \
-#  communication/modules/transport/protlib/ie.cpp \
-#  communication/modules/transport/protlib/tp_over_tcp.cpp \
-#  communication/modules/transport/protlib/setuid.cpp \
-#  communication/modules/transport/protlib/tp.cpp \
-#  communication/modules/transport/protlib/connectionmap_uds.cpp \
-#  communication/modules/transport/protlib/logfile.cpp \
-#  communication/modules/transport/protlib/timer.cpp \
-#  communication/modules/transport/protlib/connectionmap.cpp \
-#  communication/modules/transport/protlib/fqueue.cpp \
-#  communication/modules/transport/protlib/threads.cpp \
-#  communication/modules/transport/protlib/messages.cpp \
-#  communication/modules/transport/protlib/queuemanager.cpp \
-#  communication/modules/transport/protlib/network_message.cpp \
-#  communication/modules/transport/protlib/configuration.cpp \
-#  communication/modules/transport/protlib/tp_over_uds.cpp \
-#  communication/modules/transport/protlib/tp_over_udp.cpp \
-#  communication/modules/transport/protlib/tp_over_tls_tcp.cpp \
-#  communication/modules/transport/protlib/fastqueue.c \
-#  communication/modules/transport/protlib/eclock_gettime.c \
-#  communication/modules/transport/protlib/testqueue.c
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/transport/protlib/tp_over_uds.h \
-#  communication/modules/transport/protlib/threadsafe_db.h \
-#  communication/modules/transport/protlib/configuration.h \
-#  communication/modules/transport/protlib/ie.h \
-#  communication/modules/transport/protlib/llhashers.h \
-#  communication/modules/transport/protlib/fqueue.h \
-#  communication/modules/transport/protlib/assocdata_uds.h \
-#  communication/modules/transport/protlib/address.h \
-#  communication/modules/transport/protlib/logfile.h \
-#  communication/modules/transport/protlib/timer.h \
-#  communication/modules/transport/protlib/queuemanager.h \
-#  communication/modules/transport/protlib/messages.h \
-#  communication/modules/transport/protlib/assocdata.h \
-#  communication/modules/transport/protlib/protlib_types.h \
-#  communication/modules/transport/protlib/tp_over_tcp.h \
-#  communication/modules/transport/protlib/tp.h \
-#  communication/modules/transport/protlib/threads.h \
-#  communication/modules/transport/protlib/connectionmap.h \
-#  communication/modules/transport/protlib/timer_module.h \
-#  communication/modules/transport/protlib/fastqueue.h \
-#  communication/modules/transport/protlib/tperror.h \
-#  communication/modules/transport/protlib/tp_over_tls_tcp.h \
-#  communication/modules/transport/protlib/network_message.h \
-#  communication/modules/transport/protlib/tp_over_udp.h \
-#  communication/modules/transport/protlib/setuid.h \
-#  communication/modules/transport/protlib/cleanuphandler.h \
-#  communication/modules/transport/protlib/connectionmap_uds.h
-endif
-
-#------------> communication :: modules :: transport :: tcp
-
-#if OMNET
-#else
-#libariba_la_SOURCES += \
-#  communication/modules/transport/tcp/TCPTransport.cpp \
-#  communication/modules/transport/tcp/TCPTransportLocator.cpp
-
-#nobase_libariba_la_HEADERS += \
-#  communication/modules/transport/tcp/TCPTransport.h \
-#  communication/modules/transport/tcp/TCPTransportLocator.h
-#endif
 
 #------------> communication :: networkinfo